<% if (section === 'css') { %>
<style>
    #new-training-modal .modal {
        height: 100%;
    }
</style>
<% } %>

<% if (section === 'html') { %>
<div class="page" page="admin">
  <br>
  <div class="container">
    <div class="row">
      <div class="col s12 m6 row">
        <a class="col s12 btn-large waves-effect modal-trigger watervlo-blue" data-target="users-modal" onclick="connection.sendCommand('admin', 'getUsers')">Beheer gebruikers</a>
      </div>
      <div class="col s12 m6 row">
        <a class="col s12 btn-large waves-effect modal-trigger watervlo-blue" data-target="teams-modal" onclick="connection.sendCommand('admin', 'getTeams')">Beheer teams</a>
      </div>
      <div class="col s12 m6 row">
        <a class="col s12 btn-large waves-effect modal-trigger watervlo-blue" data-target="trainings-modal" onclick="connection.sendCommand('admin', 'getTrainings')">Beheer trainingen</a>
      </div>
      <div class="col s12 m6 row">
        <a class="col s12 btn-large waves-effect watervlo-blue" onclick="connection.sendCommand('global', 'refresh')">Refresh scoreborden</a>
      </div>
    </div>
  </div>

  <!-- Get users modal -->
  <div id="users-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Gebruikers</h4>
      <table>
        <thead>
          <tr>
            <th>Gebruikers naam</th>
            <th>Display naam</th>
            <th>Laatst online</th>
          </tr>
        </thead>

        <tbody id="users-table-body">
        </tbody>
      </table>
    </div>
    <div class="modal-footer">
      <a class="modal-trigger btn-flat waves-effect" data-target="new-user-modal">Nieuwe gebruiker</a>
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

  <!-- New user modal -->
  <div id="new-user-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Nieuwe gebruiker</h4>
      <form onsubmit="newUser()" action="#">
        <div class="row">
          <div class="input-field col s12">
            <input id="new-user-username" type="text" required="" aria-required="true">
            <label for="new-user-username">Gebruikersnaam</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="new-user-display-name" type="text" required="" aria-required="true">
            <label for="new-user-display-name">Display naam</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="new-user-password" type="text" placeholder="Laat leeg voor 'wachtwoord'">
            <label for="new-user-password">Wachtwoord</label>
          </div>
        </div>
        <div class="row">
          <button class="col s12 btn waves-effect watervlo-blue">Voeg toe</button>
        </div>
      </form>
    </div>
    <div class="modal-footer">
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

  <!-- Edit user modal -->
  <div id="edit-user-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Edit gebruiker</h4>
      <form onsubmit="editUser()" action="#">
        <div class="row">
          <div class="input-field col s12 tooltipped" data-position="bottom" data-tooltip="Gebruikersnaam kan je niet aanpassen">
            <input disabled id="edit-user-username" type="text" required="" aria-required="true">
            <label for="edit-user-username">Gebruikersnaam</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="edit-user-display-name" type="text" required="" aria-required="true">
            <label for="edit-user-display-name">Display naam</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="edit-user-password" type="text" placeholder="Laat leeg voor geen verandering'">
            <label for="edit-user-password">Wachtwoord</label>
          </div>
        </div>
        <p>
          <label>
            <input id="edit-user-reset-password" type="checkbox" class="filled-in"/>
            <span>Moet wachtwoord resetten</span>
          </label>
        </p>
      </form>
    </div>
    <div class="modal-footer">
      <a class="modal-close btn waves-effect red white-text" style="float: left" onclick="removeUser()">Verwijder</a>
      <a class="modal-close btn waves-effect" onclick="editUser()">Edit</a>
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

  <!-- Get teams modal -->
  <div id="teams-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Teams</h4>
      <table>
        <thead>
          <tr>
            <th>ID</th>
            <th>Team naam</th>
            <th>Afkorting</th>
          </tr>
        </thead>

        <tbody id="teams-table-body">
        </tbody>
      </table>
    </div>
    <div class="modal-footer">
      <a class="modal-trigger btn-flat waves-effect" data-target="new-team-modal">Nieuwe team</a>
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

  <!-- New team modal -->
  <div id="new-team-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Nieuwe team</h4>
      <form onsubmit="newTeam()" action="#">
        <div class="row">
          <div class="input-field col s12">
            <input id="new-team-name" type="text" required="" aria-required="true">
            <label for="new-team-name">Team naam</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="new-team-short-name" type="text" required="" aria-required="true">
            <label for="new-team-short-name">Afkorting</label>
          </div>
        </div>
        <div class="row">
          <button class="col s12 btn waves-effect watervlo-blue">Voeg toe</button>
        </div>
      </form>
    </div>
    <div class="modal-footer">
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

  <!-- Edit team modal -->
  <div id="edit-team-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Edit team</h4>
      <form onsubmit="editTeam()" action="#">
        <div class="row">
          <div class="input-field col s12 tooltipped" data-position="bottom" data-tooltip="ID kan je niet aanpassen">
            <input disabled id="edit-team-id" type="text" required="" aria-required="true">
            <label for="edit-team-id">ID</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="edit-team-name" type="text" required="" aria-required="true">
            <label for="edit-team-name">Team naam</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="edit-team-short-name" type="text" required="" aria-required="true">
            <label for="edit-team-short-name">Afkorting</label>
          </div>
        </div>
      </form>
    </div>
    <div class="modal-footer">
      <a class="modal-close btn waves-effect red white-text" style="float: left" onclick="removeTeam()">Verwijder</a>
      <a class="modal-close btn waves-effect" onclick="editTeam()">Edit</a>
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

  <!-- Get trainings modal -->
  <div id="trainings-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Trainingen</h4>
      <table>
        <thead>
          <tr>
            <th>ID</th>
            <th>Teams</th>
            <th>Dag</th>
            <th>Start tijd</th>
            <th>Eind tijd</th>
          </tr>
        </thead>

        <tbody id="trainings-table-body">
        </tbody>
      </table>
    </div>
    <div class="modal-footer">
      <a class="modal-trigger btn-flat waves-effect" data-target="new-training-modal" onclick="connection.sendCommand('admin', 'getTeams')">Nieuwe training</a>
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

  <!-- New training modal -->
  <div id="new-training-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Nieuwe training</h4>
      <form onsubmit="newTraining()" action="#">
        <div class="row">
          <div class="input-field col s12">
            <select id="new-training-teams" multiple>
            </select>
            <label>Kies je team(s)</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <select id="new-training-day">
              <option value="" disabled selected>Kies je dag</option>
              <option value="1">Maandag</option>
              <option value="2">Dinsdag</option>
              <option value="3">Woensdag</option>
              <option value="4">Donderdag</option>
              <option value="5">Vrijdag</option>
              <option value="6">Zaterdag</option>
              <option value="0">Zondag</option>
            </select>
            <label>Dag van de week</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="new-training-start-time" type="text" class="timepicker" required="" aria-required="true">
            <label for="new-training-start-time">Start tijd</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="new-training-end-time" type="text" class="timepicker" required="" aria-required="true">
            <label for="new-training-end-time">Eind tijd</label>
          </div>
        </div>
        <div class="row">
          <button class="col s12 btn waves-effect watervlo-blue">Voeg toe</button>
        </div>
      </form>
    </div>
    <div class="modal-footer">
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

  <!-- Edit team modal -->
  <div id="edit-team-modal" class="modal modal-fixed-footer">
    <div class="modal-content">
      <h4>Edit team</h4>
      <form onsubmit="editTeam()" action="#">
        <div class="row">
          <div class="input-field col s12 tooltipped" data-position="bottom" data-tooltip="ID kan je niet aanpassen">
            <input disabled id="edit-team-id" type="text" required="" aria-required="true">
            <label for="edit-team-id">ID</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="edit-team-name" type="text" required="" aria-required="true">
            <label for="edit-team-name">Team naam</label>
          </div>
        </div>
        <div class="row">
          <div class="input-field col s12">
            <input id="edit-team-short-name" type="text" required="" aria-required="true">
            <label for="edit-team-short-name">Afkorting</label>
          </div>
        </div>
      </form>
    </div>
    <div class="modal-footer">
      <a class="modal-close btn waves-effect red white-text" style="float: left" onclick="removeTeam()">Verwijder</a>
      <a class="modal-close btn waves-effect" onclick="editTeam()">Edit</a>
      <a class="modal-close btn-flat waves-effect">Sluit</a>
    </div>
  </div>

</div>
<% } %>

<% if (section === 'js') { %>
<script>
  document.addEventListener('DOMContentLoaded', function() {
    const modals = M.Modal.init(document.querySelectorAll('.modal'))
    const toolTips = M.Tooltip.init(document.querySelectorAll('.tooltipped'))
    const selects = M.FormSelect.init(document.querySelectorAll('select'))
    const timerPickers = M.Timepicker.init(document.querySelectorAll('.timepicker'), { twelveHour: false })
  });

  registerCommand('admin', 'getUsers', (data) => {
    updateUsersTable(data.users)
  })
  registerCommand('admin', 'getUser', (data) => {
    updateEditUserModal(data)
  })
  registerCommand('admin', 'getTeams', (data) => {
    updateTeamsTable(data)
    updateNewTrainingTeams(data)
  })
  registerCommand('admin', 'getTeam', (data) => {
    updateEditTeamModal(data)
  })

  // User management

  function updateUsersTable(users) {
    const tableBody = document.getElementById('users-table-body')
    tableBody.innerHTML = ''

    for (const username of Object.keys(users)) {
        const tableRow = tableBody.insertRow(-1)

        tableRow.insertCell(-1).innerHTML = username
        tableRow.insertCell(-1).innerHTML = users[username].displayName
        const d = new Date(users[username].lastOnline)
        tableRow.insertCell(-1).innerHTML = `${d.getDate().pad(2)}-${(d.getMonth()+1).pad(2)}-${d.getFullYear()} ${d.getHours().pad(2)}:${d.getMinutes().pad(2)}`
        tableRow.insertCell(-1).innerHTML = `<a class="btn waves-effect modal-trigger" data-target="edit-user-modal" onclick="connection.sendCommand('admin', 'getUser', { username: '${username}' } )">Edit</a>`
    }
  }

  function updateEditUserModal(user) {
    document.getElementById('edit-user-username').value = user.username
    document.getElementById('edit-user-display-name').value = user.displayName
    document.getElementById('edit-user-reset-password').checked = user.resetPassword

    M.updateTextFields(document.getElementById('edit-user-modal'))
  }

  function newUser() {
    const username = document.getElementById('new-user-username').value
    const displayName = document.getElementById('new-user-display-name').value
    const password = document.getElementById('new-user-password').value

    document.getElementById('new-user-username').value = ''
    document.getElementById('new-user-display-name').value = ''
    document.getElementById('new-user-password').value = ''

    M.updateTextFields(document.getElementById('new-user-modal'))

    connection.sendCommand('admin', 'newUser', { username, displayName, password: (password ? password : 'wachtwoord') } )
  }

  function editUser() {
    const username = document.getElementById('edit-user-username').value
    const displayName = document.getElementById('edit-user-display-name').value
    const password = document.getElementById('edit-user-password').value
    const resetPassword = document.getElementById('edit-user-reset-password').checked

    document.getElementById('edit-user-username').value = ''
    document.getElementById('edit-user-display-name').value = ''
    document.getElementById('edit-user-password').value = ''
    document.getElementById('edit-user-reset-password').checked = false

    M.updateTextFields(document.getElementById('edit-user-modal'))
    
    connection.sendCommand('admin', 'editUser', { username, displayName, password: (password === '' ? undefined : password), resetPassword } )
  }

  function removeUser() {
    const username = document.getElementById('edit-user-username').value

    document.getElementById('edit-user-username').value = ''
    document.getElementById('edit-user-display-name').value = ''
    document.getElementById('edit-user-password').value = ''
    document.getElementById('edit-user-reset-password').checked = false

    M.updateTextFields(document.getElementById('edit-user-modal'))

    connection.sendCommand('admin', 'removeUser', { username } )
  }

  // Team management

  function updateTeamsTable(teams) {
    const tableBody = document.getElementById('teams-table-body')
    tableBody.innerHTML = ''

    for (const id of Object.keys(teams)) {
        const tableRow = tableBody.insertRow(-1)

        tableRow.insertCell(-1).innerHTML = id
        tableRow.insertCell(-1).innerHTML = teams[id].name
        tableRow.insertCell(-1).innerHTML = teams[id].shortName
        tableRow.insertCell(-1).innerHTML = `<a class="btn waves-effect modal-trigger" data-target="edit-team-modal" onclick="connection.sendCommand('admin', 'getTeam', { id: '${id}' } )">Edit</a>`
    }
  }

  function updateEditTeamModal(team) {
    document.getElementById('edit-team-id').value = team.id
    document.getElementById('edit-team-name').value = team.name
    document.getElementById('edit-team-short-name').value = team.shortName

    M.updateTextFields(document.getElementById('edit-team-modal'))
  }

  function updateNewTrainingTeams(teams) {
    const select = document.getElementById('new-training-teams')
    select.innerHTML = ''

    for (const id of Object.keys(teams)) {
        const option = document.createElement('option')

        option.setAttribute('value', id)
        option.innerHTML = teams[id].name

        select.append(option)
    }

    const selects = M.FormSelect.init(document.querySelectorAll('select'))
  }

  function newTeam() {
    const name = document.getElementById('new-team-name').value
    const shortName = document.getElementById('new-team-short-name').value

    document.getElementById('new-team-name').value = ''
    document.getElementById('new-team-short-name').value = ''

    M.updateTextFields(document.getElementById('new-team-modal'))

    connection.sendCommand('admin', 'newTeam', { name, shortName } )
  }

  function editTeam() {
    const id = document.getElementById('edit-team-id').value
    const name = document.getElementById('edit-team-name').value
    const shortName = document.getElementById('edit-team-short-name').value

    document.getElementById('edit-team-id').value = ''
    document.getElementById('edit-team-name').value = ''
    document.getElementById('edit-team-short-name').value = ''

    M.updateTextFields(document.getElementById('edit-team-modal'))
    
    connection.sendCommand('admin', 'editTeam', { id, name, shortName } )
  }

  function removeTeam() {
    const id = document.getElementById('edit-team-id').value

    document.getElementById('edit-team-name').value = ''
    document.getElementById('edit-team-short-name').value = ''

    M.updateTextFields(document.getElementById('edit-team-modal'))

    connection.sendCommand('admin', 'removeTeam', { id } )
  }

  function newTraining() {
    const teams = M.FormSelect.getInstance(document.getElementById('new-training-teams')).getSelectedValues()
    const day = M.FormSelect.getInstance(document.getElementById('new-training-day')).getSelectedValues()[0]
    const startTime = M.Timepicker.getInstance(document.getElementById('new-training-start-time')).time
    const endTime = M.Timepicker.getInstance(document.getElementById('new-training-end-time')).time

    connection.sendCommand('admin', 'newTraining', { teams, day, startTime, endTime } )
  }
</script>
<% } %>
